
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>API Reference &#8212; crystally 29.03.2020 documentation</title>
    <link rel="stylesheet" href="_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script src="_static/language_data.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="prev" title="How do I …" href="how_do_i.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <div class="section" id="api-reference">
<h1>API Reference<a class="headerlink" href="#api-reference" title="Permalink to this headline">¶</a></h1>
<div class="section" id="vectors">
<h2>Vectors<a class="headerlink" href="#vectors" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="crystally.core.vectors.FractionalVector">
<em class="property">class </em><code class="sig-name descname">FractionalVector</code><span class="sig-paren">(</span><em class="sig-param">vector</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/vectors.html#FractionalVector"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.vectors.FractionalVector" title="Permalink to this definition">¶</a></dt>
<dd><p>A point in fractional space - e.g. in a crystal system.</p>
<p>A fractional vector has three coordinates in range [0, 1). The fractional vector space is periodic, meaning
that values greater or equal to one can be reduced: 1.1 == 0.1 and -0.2 == 0.8
This class is only a wrapper for the numpy array which checks the coordinates and the shape of the array. To access
the numpy array use <a class="reference internal" href="#crystally.core.vectors.FractionalVector.value" title="crystally.core.vectors.FractionalVector.value"><code class="xref py py-meth docutils literal notranslate"><span class="pre">value()</span></code></a>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>vector</strong> – vector like container</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>FractionalVector with altered coordinates</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">FractionalVector</span><span class="p">([</span><span class="mf">1.0</span><span class="p">,</span> <span class="mf">0.1</span><span class="p">,</span> <span class="o">-</span><span class="mf">0.6</span><span class="p">])</span>
<span class="go">FractionalVector([0.0, 0.1, 0.4])</span>
</pre></div>
</div>
<dl class="method">
<dt id="crystally.core.vectors.FractionalVector.diff">
<code class="sig-name descname">diff</code><span class="sig-paren">(</span><em class="sig-param">other</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/vectors.html#FractionalVector.diff"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.vectors.FractionalVector.diff" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the minimal distance between two FractionalVector</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>other</strong> – vector like container</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>1xN numpy array where N is the dimension of the vectors</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">FractionalVector</span><span class="p">([</span><span class="mf">0.2</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">])</span><span class="o">.</span><span class="n">diff</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="mf">0.2</span><span class="p">])</span>
<span class="go">array([-0.2,  0. ,  0.2])</span>
</pre></div>
</div>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">vec1</span> <span class="o">=</span> <span class="n">FractionalVector</span><span class="p">([</span><span class="mf">0.5</span><span class="p">,</span> <span class="mf">0.5</span><span class="p">,</span> <span class="mf">0.5</span><span class="p">])</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">vec2</span> <span class="o">=</span> <span class="n">FractionalVector</span><span class="p">([</span><span class="mf">0.6</span><span class="p">,</span> <span class="mf">0.7</span><span class="p">,</span> <span class="mf">0.8</span><span class="p">])</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">vec1</span><span class="o">.</span><span class="n">diff</span><span class="p">(</span><span class="n">vec2</span><span class="p">)</span>
<span class="go">array([0.1,  0.2 ,  0.3])</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">vec2</span><span class="o">.</span><span class="n">diff</span><span class="p">(</span><span class="n">vec1</span><span class="p">)</span>
<span class="go">array([-0.1,  -0.2 ,  -0.3])</span>
</pre></div>
</div>
</dd></dl>

<dl class="method">
<dt id="crystally.core.vectors.FractionalVector.tolist">
<code class="sig-name descname">tolist</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/vectors.html#FractionalVector.tolist"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.vectors.FractionalVector.tolist" title="Permalink to this definition">¶</a></dt>
<dd><p>Unwrap vector and get list representation of numpy array</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>list of entries</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.vectors.FractionalVector.value">
<em class="property">property </em><code class="sig-name descname">value</code><a class="headerlink" href="#crystally.core.vectors.FractionalVector.value" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the wrapped numpy array</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>numpy array</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.vectors.FractionalVector.x">
<em class="property">property </em><code class="sig-name descname">x</code><a class="headerlink" href="#crystally.core.vectors.FractionalVector.x" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the x component of this vector, is identical to vec[0]</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>depends on the entry in the vector (probably a float)</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.vectors.FractionalVector.y">
<em class="property">property </em><code class="sig-name descname">y</code><a class="headerlink" href="#crystally.core.vectors.FractionalVector.y" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the y component of this vector, is identical to vec[0]</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>depends on the entry in the vector (probably a float)</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.vectors.FractionalVector.z">
<em class="property">property </em><code class="sig-name descname">z</code><a class="headerlink" href="#crystally.core.vectors.FractionalVector.z" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the z component of this vector, is identical to vec[0]</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>depends on the entry in the vector (probably a float)</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="atom">
<h2>Atom<a class="headerlink" href="#atom" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="crystally.core.lattice.Atom">
<em class="property">class </em><code class="sig-name descname">Atom</code><span class="sig-paren">(</span><em class="sig-param">element: str = ''</em>, <em class="sig-param">position=(0</em>, <em class="sig-param">0</em>, <em class="sig-param">0)</em>, <em class="sig-param">sublattice: str = ''</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Atom"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Atom" title="Permalink to this definition">¶</a></dt>
<dd><p>An entry within a <a class="reference internal" href="#crystally.core.lattice.Lattice" title="crystally.core.lattice.Lattice"><code class="xref py py-class docutils literal notranslate"><span class="pre">Lattice</span></code></a>.</p>
<p>The Atom has three propertiers. An element from the periodic table, fractional coordinates in form of a
<a class="reference internal" href="#crystally.core.vectors.FractionalVector" title="crystally.core.vectors.FractionalVector"><code class="xref py py-class docutils literal notranslate"><span class="pre">FractionalVector</span></code></a> and a sublattice name.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>element</strong> – string of element name</p></li>
<li><p><strong>position</strong> – fractional position of the atom</p></li>
<li><p><strong>sublattice</strong> – name of the sublattice the atom is in</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Atom object</p>
</dd>
</dl>
</dd></dl>

</div>
<div class="section" id="lattice">
<h2>Lattice<a class="headerlink" href="#lattice" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="crystally.core.lattice.Lattice">
<em class="property">class </em><code class="sig-name descname">Lattice</code><span class="sig-paren">(</span><em class="sig-param">vectors=array([[1., 0., 0.],        [0., 1., 0.],        [0., 0., 1.]]), atoms=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice" title="Permalink to this definition">¶</a></dt>
<dd><p>A crystal lattice with atoms and crystal vectors</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>atoms</strong> – string of element name</p></li>
<li><p><strong>vectors</strong> – fractional position of the atom</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Lattice object</p>
</dd>
</dl>
<dl class="method">
<dt id="crystally.core.lattice.Lattice.angle">
<code class="sig-name descname">angle</code><span class="sig-paren">(</span><em class="sig-param">position1</em>, <em class="sig-param">position2</em>, <em class="sig-param">center=(0</em>, <em class="sig-param">0</em>, <em class="sig-param">0)</em>, <em class="sig-param">periodic=True</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.angle"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.angle" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the angle between two positions and a center.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>position1</strong> – fractional coordinate as list or atom</p></li>
<li><p><strong>position2</strong> – fractional coordinate as list or atom</p></li>
<li><p><strong>center</strong> – fractional coordinate as list or atom</p></li>
<li><p><strong>periodic</strong> – bool, flag that indicates if the distance should be calculated under consideration of
periodic boundaries</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>float, angle in rad</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.diff">
<code class="sig-name descname">diff</code><span class="sig-paren">(</span><em class="sig-param">other</em>, <em class="sig-param">tolerance=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.diff"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.diff" title="Permalink to this definition">¶</a></dt>
<dd><dl class="simple">
<dt>Find the atomic differences bewteen this and another lattice. Atoms are compared according to element</dt><dd><p>sublattice and position. Mind that the fractional position of this and the other lattice are converted
to cartesian coordinates with the vectors of this lattice.</p>
</dd>
</dl>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>other</strong> – other <a class="reference internal" href="#crystally.core.lattice.Lattice" title="crystally.core.lattice.Lattice"><code class="xref py py-class docutils literal notranslate"><span class="pre">Lattice</span></code></a>.</p></li>
<li><p><strong>tolerance</strong> – tolerance in angstrom with which the atoms position are compared.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>tuple with two lists, the first list consists of the atoms that were in this lattice, but were not
found in the other lattice. The second list contains the atoms that were in the other lattice, but not
found in this lattice.</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.distance">
<code class="sig-name descname">distance</code><span class="sig-paren">(</span><em class="sig-param">position1</em>, <em class="sig-param">position2</em>, <em class="sig-param">periodic=True</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.distance"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.distance" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the distance between two points</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>position1</strong> – fractional coordinate as list or atom</p></li>
<li><p><strong>position2</strong> – fractional coordinate as list or atom</p></li>
<li><p><strong>periodic</strong> – bool, flag that indicates if the distance should be calculated under consideration of
periodic boundaries</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>float, distance in Angstrom</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.find">
<code class="sig-name descname">find</code><span class="sig-paren">(</span><em class="sig-param">element=None</em>, <em class="sig-param">sublattice=None</em>, <em class="sig-param">position=None</em>, <em class="sig-param">tolerance=None</em>, <em class="sig-param">first=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.find"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.find" title="Permalink to this definition">¶</a></dt>
<dd><p>Search the atom list according to the specified parameters.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>element</strong> – element name of the atoms to get</p></li>
<li><p><strong>sublattice</strong> – sublattice name of the atoms to get</p></li>
<li><p><strong>position</strong> – position of the atoms to get within a tolerance (can be specified)</p></li>
<li><p><strong>tolerance</strong> – tolerance of positional search in angstrom.</p></li>
<li><p><strong>first</strong> – If set to <cite>True</cite> the first found atom is returned.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>list of <a class="reference internal" href="#crystally.core.lattice.Atom" title="crystally.core.lattice.Atom"><code class="xref py py-class docutils literal notranslate"><span class="pre">Atoms</span></code></a> or <a class="reference internal" href="#crystally.core.lattice.Atom" title="crystally.core.lattice.Atom"><code class="xref py py-class docutils literal notranslate"><span class="pre">Atoms</span></code></a> if first=True or <cite>None</cite> if no atoms satisfy
the criteria.</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.from_lattice">
<em class="property">static </em><code class="sig-name descname">from_lattice</code><span class="sig-paren">(</span><em class="sig-param">lattice</em>, <em class="sig-param">size_x: int = 1</em>, <em class="sig-param">size_y: int = 1</em>, <em class="sig-param">size_z: int = 1</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.from_lattice"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.from_lattice" title="Permalink to this definition">¶</a></dt>
<dd><p>Create a new lattice with an already existing one. You can also provide size values to expand the lattice.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>lattice</strong> – the <a class="reference internal" href="#crystally.core.lattice.Lattice" title="crystally.core.lattice.Lattice"><code class="xref py py-class docutils literal notranslate"><span class="pre">Lattice</span></code></a> on which the new lattice is based on</p></li>
<li><p><strong>size_x</strong> – int, multiplier by which the base lattice is expanded in x direction</p></li>
<li><p><strong>size_y</strong> – int, see size_x</p></li>
<li><p><strong>size_z</strong> – int, see size_x</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>new <a class="reference internal" href="#crystally.core.lattice.Lattice" title="crystally.core.lattice.Lattice"><code class="xref py py-class docutils literal notranslate"><span class="pre">Lattice</span></code></a></p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.get_element_names">
<code class="sig-name descname">get_element_names</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.get_element_names"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.get_element_names" title="Permalink to this definition">¶</a></dt>
<dd><p>Get all occuring <code class="xref py py-attr docutils literal notranslate"><span class="pre">Atom.element</span></code> names</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>List of strings</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.get_in_radius">
<code class="sig-name descname">get_in_radius</code><span class="sig-paren">(</span><em class="sig-param">center: Union[numpy.array, list, crystally.core.lattice.Atom], max_radius, min_radius=0.0</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.get_in_radius"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.get_in_radius" title="Permalink to this definition">¶</a></dt>
<dd><p>Get all <a class="reference internal" href="#crystally.core.lattice.Atom" title="crystally.core.lattice.Atom"><code class="xref py py-class docutils literal notranslate"><span class="pre">Atom</span></code></a> that are in range to a provided position.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>center</strong> – Search center in fractional coordinates. This can either be a list of coordinates or a <a class="reference internal" href="#crystally.core.lattice.Atom" title="crystally.core.lattice.Atom"><code class="xref py py-class docutils literal notranslate"><span class="pre">Atom</span></code></a>.</p></li>
<li><p><strong>max_radius</strong> – maximal radius in angstrom, that is searched</p></li>
<li><p><strong>min_radius</strong> – minimal radius in angstrom, that is searched. Default is 0 angstrom.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>List of <a class="reference internal" href="#crystally.core.lattice.Atom" title="crystally.core.lattice.Atom"><code class="xref py py-class docutils literal notranslate"><span class="pre">Atom</span></code></a></p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.get_sublattice_names">
<code class="sig-name descname">get_sublattice_names</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.get_sublattice_names"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.get_sublattice_names" title="Permalink to this definition">¶</a></dt>
<dd><p>Get all occuring <code class="xref py py-attr docutils literal notranslate"><span class="pre">Atom.sublattice</span></code> names</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>List of strings</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.increase_distance_abs">
<code class="sig-name descname">increase_distance_abs</code><span class="sig-paren">(</span><em class="sig-param">center</em>, <em class="sig-param">position</em>, <em class="sig-param">abs_increase</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.increase_distance_abs"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.increase_distance_abs" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to easily manipulate lattices. A center and second position need to be provided. The second
position is then shifted away from the center position by a provided value. The new position is then returned.
Mind that no variables are changed by this function.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>center</strong> – fractional coordinates of the center position. Can be a list of coordinates or a <a class="reference internal" href="#crystally.core.lattice.Atom" title="crystally.core.lattice.Atom"><code class="xref py py-class docutils literal notranslate"><span class="pre">Atom</span></code></a>.</p></li>
<li><p><strong>position</strong> – fractional coordinates of the second position. Can be a list of coordinates or a <a class="reference internal" href="#crystally.core.lattice.Atom" title="crystally.core.lattice.Atom"><code class="xref py py-class docutils literal notranslate"><span class="pre">Atom</span></code></a>.</p></li>
<li><p><strong>abs_increase</strong> – Shift in angstrom</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>new position as <a class="reference internal" href="#crystally.core.vectors.FractionalVector" title="crystally.core.vectors.FractionalVector"><code class="xref py py-class docutils literal notranslate"><span class="pre">FractionalVector</span></code></a></p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.increase_distance_rel">
<code class="sig-name descname">increase_distance_rel</code><span class="sig-paren">(</span><em class="sig-param">center</em>, <em class="sig-param">position</em>, <em class="sig-param">rel_increase</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.increase_distance_rel"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.increase_distance_rel" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to easily manipulate lattices. A center and second position need to be provided. The second
position is then shifted away from the center position by a provided percentage. The new position is then returned.
Mind that no variables are changed by this function.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>center</strong> – fractional coordinates of the center position. Can be a list of coordinates or a <a class="reference internal" href="#crystally.core.lattice.Atom" title="crystally.core.lattice.Atom"><code class="xref py py-class docutils literal notranslate"><span class="pre">Atom</span></code></a>.</p></li>
<li><p><strong>position</strong> – fractional coordinates of the second position. Can be a list of coordinates or a <a class="reference internal" href="#crystally.core.lattice.Atom" title="crystally.core.lattice.Atom"><code class="xref py py-class docutils literal notranslate"><span class="pre">Atom</span></code></a>.</p></li>
<li><p><strong>rel_increase</strong> – distance increase in percent</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>new position as <a class="reference internal" href="#crystally.core.vectors.FractionalVector" title="crystally.core.vectors.FractionalVector"><code class="xref py py-class docutils literal notranslate"><span class="pre">FractionalVector</span></code></a></p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.index">
<code class="sig-name descname">index</code><span class="sig-paren">(</span><em class="sig-param">position</em>, <em class="sig-param">tolerance=0.001</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.index"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.index" title="Permalink to this definition">¶</a></dt>
<dd><p>Get the index within the atom list of the <a class="reference internal" href="#crystally.core.lattice.Atom" title="crystally.core.lattice.Atom"><code class="xref py py-class docutils literal notranslate"><span class="pre">Atom</span></code></a> at the provided position</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>position</strong> – Position or Atom whose index is searched for</p></li>
<li><p><strong>tolerance</strong> – Tolerance in angstrom</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>index of <a class="reference internal" href="#crystally.core.lattice.Atom" title="crystally.core.lattice.Atom"><code class="xref py py-class docutils literal notranslate"><span class="pre">Atom</span></code></a></p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.remove">
<code class="sig-name descname">remove</code><span class="sig-paren">(</span><em class="sig-param">atom: crystally.core.lattice.Atom</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.remove"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.remove" title="Permalink to this definition">¶</a></dt>
<dd><p>Removes an atom from the atom list.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>atom</strong> – <a class="reference internal" href="#crystally.core.lattice.Atom" title="crystally.core.lattice.Atom"><code class="xref py py-class docutils literal notranslate"><span class="pre">Atoms</span></code></a> that should be removed. This atom has to come from the atom list in the
first place.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>None</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.size">
<em class="property">property </em><code class="sig-name descname">size</code><a class="headerlink" href="#crystally.core.lattice.Lattice.size" title="Permalink to this definition">¶</a></dt>
<dd><p>Calculates the volume of the lattice.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>volume of lattice</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.sort">
<code class="sig-name descname">sort</code><span class="sig-paren">(</span><em class="sig-param">key=None</em>, <em class="sig-param">tolerance=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.sort"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.sort" title="Permalink to this definition">¶</a></dt>
<dd><p>Sort the lattice with a given key.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>key</strong> – <p>sorting argument which is used to sort the lattice. The following aruments can be used:</p>
<ol class="arabic simple">
<li><p>”element” - will sort according to the atoms element names</p></li>
<li><p>”position” - will sort according to the atoms absolute distance to the lattice origin</p></li>
<li><p>”sublattice” - will sort according to the atoms sublattice name</p></li>
<li><p><a class="reference internal" href="#crystally.core.lattice.Lattice" title="crystally.core.lattice.Lattice"><code class="xref py py-class docutils literal notranslate"><span class="pre">Lattice</span></code></a> - this will sort this lattice according to a different lattice. Equal atoms in
this and the other lattice should then have the same position in the atoms lists. Element and
Sublattice of the atoms are compared for equality. The position is compared with a tolerance in
angstrom. This means that if the atoms are closer together than the tolerance, their position
is treated as equal.</p></li>
</ol>
</p></li>
<li><p><strong>tolerance</strong> – tolerance parameter which will be used when sorting this lattice with another lattice. If
None is specified the default value of constants.ABS_VEC_COMP_TOL is used.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>nothing</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.to_cartesian">
<code class="sig-name descname">to_cartesian</code><span class="sig-paren">(</span><em class="sig-param">position</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.to_cartesian"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.to_cartesian" title="Permalink to this definition">¶</a></dt>
<dd><p>Translates fractional coordinates to cartesian coordinates.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>position</strong> – fractional coordinates</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>cartesian coordinates</p>
</dd>
</dl>
</dd></dl>

<dl class="method">
<dt id="crystally.core.lattice.Lattice.to_fractional">
<code class="sig-name descname">to_fractional</code><span class="sig-paren">(</span><em class="sig-param">position</em>, <em class="sig-param">periodic=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/lattice.html#Lattice.to_fractional"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.lattice.Lattice.to_fractional" title="Permalink to this definition">¶</a></dt>
<dd><p>Translates cartesian coordinates to fractional coordinates.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>position</strong> – cartesian coordinates</p></li>
<li><p><strong>periodic</strong> – if periodic is set to <cite>True</cite>. The fractional coordinates are translated
to a value between 0 and 1.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>fractional coordinates</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="file-handling">
<h2>File handling<a class="headerlink" href="#file-handling" title="Permalink to this headline">¶</a></h2>
<dl class="function">
<dt id="crystally.core.file_handling.read_poscar">
<code class="sig-name descname">read_poscar</code><span class="sig-paren">(</span><em class="sig-param">file</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/file_handling.html#read_poscar"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.file_handling.read_poscar" title="Permalink to this definition">¶</a></dt>
<dd><p>Reads the lattice from a file in vasp POSCAR style.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>file</strong> – the file that should be read</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a <a class="reference internal" href="#crystally.core.lattice.Lattice" title="crystally.core.lattice.Lattice"><code class="xref py py-class docutils literal notranslate"><span class="pre">Lattice</span></code></a> object</p>
</dd>
</dl>
</dd></dl>

<dl class="function">
<dt id="crystally.core.file_handling.write_poscar">
<code class="sig-name descname">write_poscar</code><span class="sig-paren">(</span><em class="sig-param">lattice: crystally.core.lattice.Lattice</em>, <em class="sig-param">file: str</em>, <em class="sig-param">poscar_description: str</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/crystally/core/file_handling.html#write_poscar"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#crystally.core.file_handling.write_poscar" title="Permalink to this definition">¶</a></dt>
<dd><p>Write a lattice to a file in the vasp POSCAR format.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>lattice</strong> – a <a class="reference internal" href="#crystally.core.lattice.Lattice" title="crystally.core.lattice.Lattice"><code class="xref py py-class docutils literal notranslate"><span class="pre">Lattice</span></code></a> object</p></li>
<li><p><strong>file</strong> – the file name</p></li>
<li><p><strong>poscar_description</strong> – the description that is written to the head of the file</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>None</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="index.html">crystally</a></h1>








<h3>Navigation</h3>
<p class="caption"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="how_do_i.html">How do I …</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">API Reference</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#vectors">Vectors</a></li>
<li class="toctree-l2"><a class="reference internal" href="#atom">Atom</a></li>
<li class="toctree-l2"><a class="reference internal" href="#lattice">Lattice</a></li>
<li class="toctree-l2"><a class="reference internal" href="#file-handling">File handling</a></li>
</ul>
</li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="index.html">Documentation overview</a><ul>
      <li>Previous: <a href="how_do_i.html" title="previous chapter">How do I …</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2020, John P. Arnold.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 2.4.4</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="_sources/api_reference.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>